#ifndef __SEEDCORE_API__
#define __SEEDCORE_API__

#include <sys/types.h>

#ifndef IOCTLTEST_MAGIC
#define IOCTLTEST_MAGIC    't'
#endif

#define IOCTL_GET_REG		_IO(IOCTLTEST_MAGIC, 6)
#define IOCTL_SET_REG		_IO(IOCTLTEST_MAGIC, 7)
#define IOCTL_GET_DROP_CNT	_IO(IOCTLTEST_MAGIC, 8)
#define IOCTL_RESET		_IO(IOCTLTEST_MAGIC, 9)

/* define the mode when data is received */
#define RXMODE_PATTERN		0x5555AAAA 
#define RXMODE_AFTER_PATTERN	1 
#define RXMODE_WITHOUT_PATTERN	0 

#define ONEK_BLK	1024 
#define TENK_BLK	(1024*10) 


typedef struct pcidrv_ioctl_val
{
	u_int		val;
	volatile u_long	addr;
} __attribute__ ((packed)) PCIDRV_INFO;


int sfpdp_start(int ch, int mode);
int sfpdp_send(int ch, char* buf, int size);
int sfpdp_recv_single(int ch, unsigned int* buf, int size);
int sfpdp_recv(int ch, char* buf, int size, int usrtimeout);
int sfpdp_init();
int sfpdp_close();
int sfpdp_reset(int ch);
int sfpdp_bd_reset();

#endif

