/*
 * This is functions to read register values. 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>		// strlen()
#include <unistd.h>		// read, write
#include <fcntl.h>		// open, close, O_RDWR, O_NONBLOCK
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include "sfpdp-api.h"

#define MAX_OFFSET_NUM	10	/* Max Offset Address */


int main( int argc, char **argv )
{
	int fd;
	int bsaddr;
	unsigned int base_addr;
	char devfilename[128];
	PCIDRV_INFO pi;
	int i;

	if( argc != 2 ) printf( "!Usage: %s [addr(x10000)]\n\n", argv[0] );

	if( argc > 2 ) return -1; 

	if( argc == 1 )
		while(1) {
			printf( "Select the addr you want to view its register values. \n" );
			printf( "Range of the addr is from 0 to %d (x10000): ", MAX_OFFSET_NUM );
			scanf( "%d", &bsaddr );
			if( (bsaddr<0) || (bsaddr> MAX_OFFSET_NUM) ) {
				printf( "Range of the Addr is over. \n" );
				continue; 
			}
			else break; 
		}

	else if( argc == 2 ) {
		bsaddr = atoi( argv[1] );
		if( (bsaddr<0) || (bsaddr> MAX_OFFSET_NUM) ) {
			printf( "Range of the Addr is over. \n" );
			return -1; 
		}
	}
	else	return -1; 
/*
	sprintf( devfilename, "/dev/gef_gpio" );
*/
	sprintf( devfilename, "/dev/%s0", SFPDP_DEV_NAME );
	fd = open( devfilename, O_RDWR|O_SYNC );
	if( !(0<fd) ) {
		printf( "Devide file(%s) open fail.\n", devfilename );
		return -1; 
	}
	printf( "**device file(%s) open.. ok!\n", devfilename );
	base_addr = 0x10000 * bsaddr;
	printf( "Register Base Addr: 0x%08X\n\n", base_addr );

	for( i=0; i<64; i++ ) {

		pi.addr = base_addr + 0x04*i;
		ioctl(fd, IOCTL_GET_REG, &pi);
		printf( "SFPDP 0x%02X 0X%08X \n", pi.addr, pi.val);
	}

	close(fd);
	printf("**close()\n");
	return 0;
}

