/*
 * This is a Header file for API functions of SFPDP card.
 */

#ifndef __SFPDPAPI__
#define __SFPDPAPI__

#include <sys/types.h>

#ifndef IOCTLTEST_MAGIC
#define IOCTLTEST_MAGIC    't'
#endif

#define IOCTL_GET_REG		_IO(IOCTLTEST_MAGIC, 6)
#define IOCTL_SET_REG		_IO(IOCTLTEST_MAGIC, 7)
#define IOCTL_GET_DROP_CNT	_IO(IOCTLTEST_MAGIC, 8)
#define IOCTL_RESET		_IO(IOCTLTEST_MAGIC, 9)

#define SFPDP_DEV_NAME	"scsfpdp" 

/* define the SWDV mode */
#define SFPDP_TX_SWDV_MASK	0x08000000

/* define the pattern mode when data is received */
#define SFPDP_RX_AFTER_PATTERN		0x5555AAAA 
#define SFPDP_RX_PATTERN_MODE_MASK	0x01000000

/* define DMA send and recv Frame Size, which should be the same or less than that of DMA Frame */
#define TX_FRMSIZE	(1024*1024*2)
#define RX_FRMSIZE	(1024*8)

#define NUM_OF_DMA	4

/* define User Buffer size */
#define TXRX_BUFSIZE	(1024*1024*2)
#define TX_BUFSIZE	TXRX_BUFSIZE
#define RX_BUFSIZE	TXRX_BUFSIZE

#define CH_FIRST_ADDR	0x50000 
#define CTL_REG_ADDR	0x90000		// Control register addr.

#define sc_wmb() asm volatile("":::"memory")


/* define Buffer size for Hanwha Sinaro */
#define HAN_BUFSIZE	(2*1024*1024)
#define BASIC_PKTSIZE	0


typedef struct pcidrv_ioctl_val {
	u_int		val;
	volatile u_long	addr;

} __attribute__ ((packed)) PCIDRV_INFO;


#ifdef _DEBUG_
void print_buff( unsigned char *, int );
void print_bigbuff( unsigned char *, int );
#endif
int sfpdp_init_control(int ch, unsigned int mode);
int sfpdp_send(int ch, char* buf, int size);
int sfpdp_send_with_swdv(int ch, char* buf, int size);
int sfpdp_recv(int ch, char* buf, int size, int usrtimeout);
int sfpdp_recv_single(int ch, char *buf, int size);
int sfpdp_init();
int sfpdp_bdbuf_clear();
int sfpdp_all_bdbuf_clear();
int sfpdp_ch_open();
int sfpdp_ch_close();
int sfpdp_all_open();
int sfpdp_all_close();
int sfpdp_reset(int ch);
int sfpdp_bd_reset();

#endif

