/*
 * This is to change the mode when sFPDP card transfers data.
 */
#include <stdio.h>
#include <string.h>		// strlen()
#include <unistd.h>		// read, write
#include <fcntl.h>		// open, close, O_RDWR, O_NONBLOCK
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include "my_ioctl.h"

#define XAXIDMA_TX_CR_OFFSET    0x00000000 /* Channel control */
#define XAXIDMA_TX_SR_OFFSET    0x00000004 /* Status */
#define XAXIDMA_DELAY_MASK      0xFF000000 /* Delay timeout counter */
#define XAXIDMA_COALESCE_MASK       0x00FF0000 /* Coalesce counter */

#define XAXIDMA_CR_RESET_MASK   0x00000004 /* Reset DMA engine */

#define XAXIDMA_DELAY_SHIFT     24
#define XAXIDMA_COALESCE_SHIFT      16

#define XAXIDMA_DFT_TX_THRESHOLD    32
#define XAXIDMA_DFT_TX_WAITBOUND    254
#define XAXIDMA_DFT_RX_THRESHOLD    32
#define XAXIDMA_DFT_RX_WAITBOUND    254

#define XAXIDMA_IRQ_ALL_MASK        0x00007000 /* All interrupts */

int main()
{
	int fd;
	PCIDRV_INFO pi;
	unsigned long timeout;
	int i;
	int offset = 0;
	unsigned int mode = 0;
	unsigned int val = 0;

	printf("Select Mode : 1(SFPDP RESET), 2(SFPDP COPY-MODE) : ");
	scanf("%d", &offset);
	if( (offset != 1) && (offset != 2) ) {
		printf("Invalid offset \n");
		return -1;
	}
	printf("\n");

	if(offset == 1)
	{
		printf("Select Reset value \n");
		printf("  1(0x00600003) : Default\n");
		printf("  2(0x02600003) : Receive all data\n");
		printf("  3(0x03600003) : Receive data after 0x5555AAAA,\n");
		printf("INPUT >> ");
		scanf("%d", &mode);

		if(mode == 1)	val = 0x00600003;
		else if(mode == 2) val = 0x02600003;
		else if(mode == 3) val = 0x03600003;
		else {
			printf("invalid value \n");
			return -1;
		}
	}

	else if (offset == 2)
	{
		printf("Select Copy-mode value \n");
		printf("  1(0x00600007) : Default\n");
		printf("  2(0x02600007) : Receive all data\n");
		printf("  3(0x03600007) : Receive data after 0x5555AAAA,\n");
		printf("INPUT >> ");
		scanf("%d", &mode);

		if(mode == 1)	val = 0x00600007;
		else if(mode == 2) val = 0x02600007;
		else if(mode == 3) val = 0x03600007;
		else {
			printf("invalid value \n");
			return -1;
		}
	}

	if (0 < (fd = open(SCSFPDP1, O_RDWR | O_SYNC))) {
		printf("***open()\n");

		for(i=3; i>=0; i--) {
/*
			pi.addr = 0x50000 + (0x10000*i) + 0x0c;
			pi.val = 0x01;
			ioctl(fd, IOCTL_SET_REG, &pi);
			usleep(1000*100);
*/
			pi.addr = 0x50000 + (0x10000*i) + 0x18;
			pi.val = val;
			ioctl(fd, IOCTL_SET_REG, &pi);
			printf("Set REG(0x%2x) Val(0x%08x) \n", pi.addr, pi.val);
			usleep(1000*100);
/*
			pi.addr = 0x50000 + (0x10000*i) + 0x0c;
			pi.val = 0x00;
			ioctl(fd, IOCTL_SET_REG, &pi);
*/
			ioctl(fd, IOCTL_GET_REG, &pi);
			printf("SFPDP[%d] 0x18 0x%08x\n", i, pi.val);

//			usleep(1000*100);
			sleep(1);
		}

		close(fd);
		printf("***close()\n");
	} else 
		printf("open fail \n");

	return 0;
}

