#include <stdio.h>
#include <string.h>		// strlen()
#include <unistd.h>		// read, write
#include <fcntl.h>		// open, close, O_RDWR, O_NONBLOCK
#include <sys/types.h>
#include <sys/ioctl.h>
#include <linux/types.h>
#include "my_ioctl.h"

#define XAXIDMA_TX_CR_OFFSET    0x00000000 /* Channel control */
#define XAXIDMA_TX_SR_OFFSET    0x00000004 /* Status */
#define XAXIDMA_DELAY_MASK      0xFF000000 /* Delay timeout counter */
#define XAXIDMA_COALESCE_MASK       0x00FF0000 /* Coalesce counter */

#define XAXIDMA_CR_RESET_MASK   0x00000004 /* Reset DMA engine */

#define XAXIDMA_DELAY_SHIFT     24
#define XAXIDMA_COALESCE_SHIFT      16

#define XAXIDMA_DFT_TX_THRESHOLD    32
#define XAXIDMA_DFT_TX_WAITBOUND    254
#define XAXIDMA_DFT_RX_THRESHOLD    32
#define XAXIDMA_DFT_RX_WAITBOUND    254

#define XAXIDMA_IRQ_ALL_MASK        0x00007000 /* All interrupts */

int main()
{
	int fd;
	PCIDRV_INFO pi;
	unsigned long timeout;
	int i;
	int offset = 0;
	int reg = 0;


	if (0 < (fd = open( SCSFPDP3, O_RDWR | O_SYNC)))
	{
		while(1)
		{
			printf("*****************************************\n");
#if 1
			for(i=0; i<4; i++)
			{
				pi.addr = 0x50000 + (0x10000*i) + 0x30;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] TX packet pass count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x34;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] TX DMA packet count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x38;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] TX DMA byte count %d\n\n", i, pi.val);
			}
#endif
#if 0
			for(i=0; i<4; i++)
			{
				pi.addr = 0x50000 + (0x10000*i) + 0x20;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] RX packet drop count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x24;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] RX packet pass count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x28;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] RX CRC Errror Count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x2c;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] RX Disparity Error Count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x3c;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] RX DMA packet count %d\n", i, pi.val);

				pi.addr = 0x50000 + (0x10000*i) + 0x40;
				ioctl(fd, IOCTL_GET_REG, &pi);
				printf("ch[%d] RX DMA byte count %d\n\n", i, pi.val);

			}
#endif

			printf("*****************************************\n");
			sleep(1);
		}

		close(fd);
		printf("***close()\n");

	} else 
		printf("open fail \n");

	return 0;
}
